;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
.386p
CSEG segment use16
assume cs:cseg, ds:cseg, ss:cseg, es:cseg
	org	100h
start:
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
Code_selector		equ  8		; selector
Stack_selector		equ 16		; Index 13 bit
Data_selector		equ 24		; RPL - Requested Privilege Level 2 bit
Screen_selector		equ 32		; 00-Ring0....
R_Mode_Code		equ 40		; TI 0- Global DT, 1- Local DT 1 bit
R_Mode_Data		equ 48		; [----INDEX---- TI RPL]
;--------------------------------------------------------------------------
	mov	R_Mode_SS,ss
	mov	R_Mode_DS,ds
	mov	R_Mode_ES,es
	mov	R_Mode_FS,fs
	mov	R_Mode_GS,gs

	mov	R_Mode_segment,cs
	lea	ax,R_Mode_entry
	mov	R_Mode_offset,ax

	mov	bx,offset GDT + 8	; P - Present; 1 - memory, 0 - virtual memory
	xor	eax,eax			; DPL - Descriptor Privilege Level
	xor	edx,edx			; S - System, 1 - code or data, 0 - system object
	push	cs			; Type 3: 1 code, 0 data; 2 - direction: 0 - usual, 1 like stack; 1: 1 writable 0 not; 
	pop	ax			; A - Acessed, 
	shl	eax,4			; segment base address
	mov	dx,1024			; segment limit
	mov	cl,10011000b		; P=1, DPL=00b, S=1, Type=100b, A=0
	call	set_descriptor		; Code

	lea	dx,Stack_seg_start	; 
	add	eax,edx			; 
	mov	dx,1024			; segment limit
	mov	cl,10010110b		; P=1, DPL=00b, S=1, Type=011b, A=0
	call	set_descriptor		; Stack

	xor	eax,eax			; 
	mov	ax,ds			; 
	shl	eax,4			; 
	mov	dx,0ffffh		; segment limit
	mov	cl,10010010b		; P=1, DPL=00b, S=1, Type=001b, A=0
	call	set_descriptor		; Data

	mov	eax,0b8000h		; 
	mov	edx,4000		; segment limit
	mov	cl,10010010b		; P=1, DPL=00b, S=1, Type=001b, A=0
	call	set_descriptor		; Screen

	xor	eax,eax			; 
	push	cs			; 
	pop	ax			; 
	shl	eax,4			; 
	mov	edx,0ffffh		; segment limit
	mov	cl,10011010b		; P=1, DPL=00b, S=1, Type=101b, A=0
	call	set_descriptor		; R_Mode_Code
	mov	cl,10010010b		; P=1, DPL=00b, S=1, Type=001b, A=0
	call	set_descriptor		; R_Mode_Data

	xor	eax,eax			; 47-16: GDT offset
	xor	edx,edx			; 15- 0: GDT limit, max offset from begining
	mov	ax,ds			; 
	shl	eax,4			; 
	lea	dx,GDT			; 
	add	eax,edx			; 
	mov	GDT_adr,eax		; 
	mov	dx,55			; GDT limit = 8 * (1 + 6) - 1
	mov	GDT_lim,dx		; 

	cli				; 
	lgdt	GDTR			; GDTR

	mov	R_Mode_SP,sp		; 

	mov	eax,cr0			; Protected Mode
	or	al,1			; 
	mov	cr0,eax			; 

	db	0eah			; far jmp 
	dw	P_Mode_entry		; 
	dw	Code_selector
;--------------------------------------------------------------------------
P_Mode_entry:
	mov	ax,Screen_selector
	mov	es,ax
	mov	ax,Data_selector
	mov	ds,ax
	mov	ax,Stack_selector
	mov	ss,ax
	mov	sp,0

	lea	bx,Start_P_Mode_ZS
	mov	di,480
	call	putzs

	lea	bx,P_Mode_ZS
	add	di,160
	call	putzs

;--------------------------------------------------------------------------
	;cli

	db	0eah		; far jmp R_Mode_Code:Pre_R_Mode_entry.
	dw	Pre_R_Mode_entry
	dw	R_Mode_Code

Pre_R_Mode_entry:
	mov	ax,R_Mode_Data	; 
	mov	ss,ax
	mov	ds,ax
	mov	es,ax
	mov	fs,ax
	mov	gs,ax

	mov	eax,cr0
	and	al,0feh		; 
	mov	cr0,eax

		db	0eah	; far jmp 
R_Mode_offset	dw	?	; 
R_Mode_segment	dw	?	; 
				; 
;------------------------------------------------------------------------
R_Mode_entry:

	mov	ss,R_Mode_SS
	mov	ds,R_Mode_DS
	mov	es,R_Mode_ES
	mov	fs,R_Mode_FS
	mov	gs,R_Mode_GS
	mov	sp,R_Mode_SP	; 

	sti

	lea	bx,R_Mode_ZS
	mov	ax,0b800h
	mov	es,ax
	mov	di,800
	call	putzs		; 

	int	20h		; exit

;-------------------------------------------------------------------------
set_descriptor	proc	near	; create descriptor

	push	eax		; 0..15:  segment limit 0..15
	push	ecx		; 16..31: segment base address 0..15
	push	cx		; 32..39: segment base address 16..23
	mov	cx,ax		;     40: A (Accessed)
	shl	ecx,16		; 41..43: Type
	mov	cx,dx		;     44: S (System)
	mov	[ bx ],ecx	;  45,46: DPL (Descriptor Privilege Level)
	shr	eax,16		;     47: P (Present)
	mov	cl,ah		; 48..51: segment limit 16..19
	shl	ecx,24		;     52: U (User)
	mov	cl,al		;     53: X (reserved)
	pop	ax		;     54: D (Default size)
	mov	ch,al		;     55: G (Granularity)
	mov	[ bx + 4 ],ecx	; 56..63: segment base address 24..31
	add	bx,8		; 
	pop	ecx		; 
	pop	eax		; 
	ret

set_descriptor	endp
;-------------------------------------------------------------------------
putzs	proc	near		; zero string to video memory

	push	ax
	push	bx
	push	es
	push	di
	mov	ah,1bh		; 
putzs_1:
	mov	al,[bx]		; 
	inc	bx		; 
	cmp	al,0		; 
	je	putzs_end	; 
	mov	es:[di],ax	; 
	add	di,2		; 
	jmp	putzs_1		; 
				; 
putzs_end:
	pop	di
	pop	es
	pop	bx
	pop	ax
	ret

putzs		endp
;--------------------------------------------------------------------------
Start_P_Mode_ZS		db	"Entering to protected mode...",0
P_Mode_ZS		db	"Working in P-mode...",0
R_Mode_ZS		db	"Back to real address mode...",0

R_Mode_SP		dw	?
R_Mode_SS		dw	?
R_Mode_DS		dw	?
R_Mode_ES		dw	?
R_Mode_FS		dw	?
R_Mode_GS		dw	?
;--------------------------------------------------------------------------
;   GDTR:

GDTR	label		fword
GDT_lim			dw	?
GDT_adr			dd	?
;--------------------------------------------------------------------------
GDT:
	dd	?,?	; 0 descriptor
	dd	?,?	; 1 descriptor (code)
	dd	?,?	; 2 descriptor (stack)
	dd	?,?	; 3 descriptor (data)
	dd	?,?	; 4 descriptor (screen)
	dd	?,?	; 5 descriptor (code R-Mode)
	dd	?,?	; 6 descriptor (stack and data R-Mode)

;--------------------------------------------------------------------------
;PMode_data_start:	;      .
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------
;PMode_data_end:		;   .
;--------------------------------------------------------------------------
	db	1024 dup (?)	; Stack.
Stack_seg_start:	; Stack beginning.
;--------------------------------------------------------------------------
	CSEG	ends
	end	start